/*! phoscon-app 2022-09-19 */

import{injectSwitchWizzardSvg}from"./devices/load-svg.js";import{initMachine}from"./devices/machine.js";import{createMachineContent}from"./devices/make-machine.js";import{getPageContent,translatePage}from"./devices/load-page.js";import{getScanStates}from"./devices/scan-states.js";import{START_SCAN,STOP_SCAN,DEVICE_ADDED,DEVICE_UPDATED,DEVICE_NO_UPDATED,NO_DEVICE_ADDED}from"./devices/scan-states.js";import{iOS,addClassToAll,removeClassToAll,callFunc}from"./devices/generic-helper-functions.js";import{actions as pageActions}from"./devices/machine-actions.js";import*as c from"./devices/constants.js";import*as install_c from"./devices/constants-installcode.js";import*as s from"./devices/scan-states.js";import*as scanActions from"./devices/scan-actions.js";import*as scanFunctions from"./devices/scan-functions.js";import*as installFunctions from"./devices/installcode-functions.js";import{initDevicesSwitchView}from"./devices-switches/devices-switches-view.js";import{initPages}from"./devices-switches/map.js";import{initOverview}from"./devices-switches/overview-view.js";import{initDetailsView}from"./devices-switches/details-view.js";const{Machine:Machine}=XState,{interpret:interpret}=XStateInterpreter;async function initViewAndLogic(){screenMin(SCREEN_MIN_WIDTH_TABLET_PORTRAIT)&&openNav();var overviewInitial=0!==app.switches.models.length?"table":"empty";const pageParams={constants:c,i_constants:install_c,scanStates:s},generalViews=initOverview(injectSwitchWizzardSvg,pageParams),detailsView=initDetailsView(injectSwitchWizzardSvg,pageParams);generalViews.detailsView=detailsView;const pages=initPages(pageParams),view=await initDevicesSwitchView(iOS,addClassToAll,removeClassToAll,injectSwitchWizzardSvg),states=await createMachineContent(pages,c,install_c),scanStates=await getScanStates(scanActions),functions=await getMachineFunctions(scanFunctions,getPageContent,translatePage,installFunctions),actions=await getPageActions(pageActions);let context={overviewInitial:overviewInitial,...functions,callFunc:callFunc,view:view,generalViews:generalViews,constants:{...c,...install_c,START_SCAN:START_SCAN,STOP_SCAN:STOP_SCAN,DEVICE_ADDED:DEVICE_ADDED,DEVICE_UPDATED:DEVICE_UPDATED,DEVICE_NO_UPDATED:DEVICE_NO_UPDATED,NO_DEVICE_ADDED:NO_DEVICE_ADDED},pageParams:pageParams,noteSw:{}},pagesStates={id:"pages",initial:"page-init",states:states};const machine=await initMachine(pagesStates,scanStates,actions,Machine,interpret,context);app.machine=machine;var service=machine.context.service;view.service=service,generalViews.tableView.views.forEach(view=>{view.service=service},this),app.navItem=document.querySelector("#dSwitch2").parentElement,app.navItem.addEventListener("click",function(){app.router.navigate("table",{trigger:!0})}),app.headLeftBtn=document.querySelector(".header #menu-btn"),app.headLeftSvg=app.headLeftBtn.querySelector("use"),app.headLeftLabel=app.headLeftBtn.querySelector("span");var Router=Backbone.Router.extend({routes:{"table/wizard/:page":"showSwitchWizard","switch/:id":"showSwitchDetails",table:"showSwitchTable"},showSwitchDetails:function(id){app.navItem.classList.add("sub-item");let sw=app.switches.get(id);sw&&service.send({type:"DETAILS",model:sw}),(screenMax(SCREEN_MAX_WIDTH_PHONE_PORTRAIT)||screen.height<420)&&(app.headLeftSvg.setAttribute("xlink:href","#back-icon-sm"),app.headLeftLabel.textContent=translate("link_switches"))},showSwitchTable:function(url){app.session.swid=void 0,app.headLeftSvg.setAttribute("xlink:href","#icon-hamburger-sm"),app.headLeftLabel.textContent="",app.navItem.classList.remove("sub-item"),app.switches.length>0?service.send("TABLE"):service.send("EMPTY")},showSwitchWizard:function(page){console.log("showSwitchWizard: "+page),service.send(page)}});app.router=new Router,Backbone.history.start();let backboneHistoryFragment=Backbone.history.getFragment();-1!==backboneHistoryFragment.indexOf("wizard")&&($("#switchWizardModal").modal("show"),-1!==backboneHistoryFragment.indexOf("switch")?app.machine.context.nodeHistoryFragment="switch/"+app.session.swid:app.machine.context.nodeHistoryFragment="table"),app.headLeftBtn.onclick=void 0,app.headLeftBtn.addEventListener("click",function(){(screenMax(SCREEN_MAX_WIDTH_PHONE_PORTRAIT)||screen.height<420)&&document.location.hash.indexOf("switch/")>0?app.router.navigate("table",{trigger:!0}):openNav()}),app.switches.on("add",function(sw){machine.context.noteSw.id=sw.id,app.session.swid=sw.id,machine.context.service.send({type:DEVICE_ADDED,device:sw})},this),app.api.on("switch-added",function(sw){machine.context.noteSw.id=sw.id,app.session.swid=sw.id,machine.context.service.send({type:DEVICE_ADDED,device:sw})},this),app.switches.on("change",function(sw){sw&&sw.attributes&&(machine.context.noteSw.id=sw.id,app.session.swid=sw.id,service.send({type:DEVICE_UPDATED,device:sw}))},this),document.querySelectorAll("[data-modal]").forEach(elem=>{elem.addEventListener("click",function(e){let el=e.currentTarget;if(!el)return;let ev=el.getAttribute("data-btn-ev");service.send(ev)})}),loadLanguage(),$(document).on("show.bs.modal","#deleteSwitchModal",function(){var sw=app.switches.get(app.session.swid),name=sw.get("name");this.querySelector(".modal-body span b").innerText=name,this.querySelector(".modal-footer .btn-primary").addEventListener("click",function(){deleteSwitch(sw,service)})}),document.querySelectorAll(".dev-scroll-cont").forEach(el=>{el.onscroll=function(){setShadowClass(this)}})}function getMachineFunctions(s,getPageContent,translatePage,installFunctions){return{enableSensorSearch:s.enableSensorSearch,disableSensorSearch:s.disableSensorSearch,blinkAllLights:s.blinkAllLights,renameSwitch:s.renameSwitch,getPageContent:getPageContent,translatePage:translatePage,routeToDetails:routeToDetails,setShadowClass:setShadowClass,initPages:initPages,...installFunctions}}function getPageActions(actions){return{...actions,[c.CALL_FUNC]:callFunc}}function deleteSwitch(sw,service){sw&&(sw.destroy(),app.router.navigate("table",{trigger:!0}))}function routeToDetails(ctx,event){ctx.noteSw&&ctx.noteSw.id&&(app.router.navigate("switch/"+ctx.noteSw.id,{trigger:!0}),ctx.noteSw.id=void 0)}function setShadowClass(el){el.classList[el.scrollTop>10?"add":"remove"]("shadow-top"),el.classList[el.scrollHeight-el.clientHeight-el.scrollTop>10?"add":"remove"]("shadow-bottom")}function locationHashChanged(e){if(!iOS)return;let oldHash=e.oldURL.split("#")[1],newHash=e.newURL.split("#")[1];oldHash&&newHash&&-1!==oldHash.indexOf("scan")&&-1==newHash.indexOf("scan")&&setTimeout(()=>{scanFunctions.disableSensorSearch()},2e3)}initApp(),restGetResource(app.config).then(()=>restGetResource(app.sensors)).then(res=>{setTimeout(()=>app.poll.pollRepeated(app.config),5e3),setTimeout(()=>app.poll.pollRepeated(app.sensors),5e3),app.sensorScan.fetch(),initViewAndLogic()}),window.onhashchange=locationHashChanged;